#!/usr/bin/perl -w

use strict;

######################################################################
# hier das gewuenschte bundesland entkommentieren

#my $Land = "baden-wuerttemberg";
#my $Land = "bayern";
#my $Land = "berlin-brandenburg";
#my $Land = "bremen";
#my $Land = "hamburg";
#my $Land = "hessen";
#my $Land = "mecklenburg-vorpommern";
#my $Land = "niedersachsen";
 my $Land = "nordrhein-westfalen";
#my $Land = "rheinland-pfalz";
#my $Land = "saarland";
#my $Land = "sachsen";
#my $Land = "sachsen-anhalt";
#my $Land = "schleswig-holstein";
#my $Land = "thueringen";

######################################################################
# ab hier sollten keine aenderungen noetig sein

my $usefull_page  = 0; # be pessimistic :(
my $meldungen     = 0; # be optimistic  ;)
my $url           = "http://www.rp-online.de/ratgeber/auto+verkehr/staumelder/index.phtml/$Land";
my $lynx_cmd      = "lynx -dump -width 900 $url";

open(OUT, ">/tmp/staumeldungen.rdf") || die "cannot open outfile for writing";
open(IN, "$lynx_cmd|") || die "ERROR: cannot start/open lynx";
while(<IN>)
{	#print header
	if ( /aktuelle verkehrsinformationen aus (.*)/ )
	{	my $bundesland   = $1;
		print OUT "<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?>\n"
			. "<rdf:RDF\n"
			. "xmlns:rdf=\"http://www.w3.org/1999/02/22-rdf-syntax-ns#\"\n"
			. "xmlns=\"http://my.netscape.com/rdf/simple/0.9/\">\n\n"
			. "<channel>\n"
			. "  <title>rp-online stauinfos ($bundesland)</title>\n"
			. "  <link>http://www.rp-online.de/</link>\n"
			. "  <description>rp-online stauinfos ($bundesland)</description>\n"
			. "</channel>\n";
			$usefull_page = 1;
	}
        # insert staumeldungen
	if ( /.*(\[.*\]).*(\(\d\d:\d\d Uhr\))/ )
	{	my $autobahn    = $1;
		my $uhrzeit     = $2;
		my $dummy       = <IN>;
		my $text1       = <IN>;
		my $text2       = <IN>;
		my $staumeldung = "$autobahn $uhrzeit - $text1 - $text2";

		$staumeldung =~ s/\n//g;
		$staumeldung =~ s/  / /g; $staumeldung =~ s/  / /g; $staumeldung =~ s/  / /g; 
		$staumeldung =~ s/  / /g; $staumeldung =~ s/  / /g; $staumeldung =~ s/  / /g;
		$staumeldung =~ s/  / /g; $staumeldung =~ s/  / /g; $staumeldung =~ s/  / /g; 
		$staumeldung =~ s/  / /g; $staumeldung =~ s/  / /g; $staumeldung =~ s/  / /g; 

                print OUT "<item>\n"
			. "  <title>$staumeldung</title>\n"
			. "  <link>undef</link>\n"
			. "</item>\n";
		$meldungen++;

	}
}
close(IN);

print OUT "</rdf:RDF>\n";
close(OUT);

if ( $usefull_page != 1 ) { print STDERR "$0 ERROR: page does not seem to be usefull\n"
					."url: $url\n\n";  }
if ( $meldungen    != 0 ) { # keine staumeldungen vorhanden 
}
